// VCSampleDlg.h : header file
//

#if !defined(AFX_VCSAMPLEDLG_H__76E480AE_9914_4D00_AEB0_4838EAA5F53A__INCLUDED_)
#define AFX_VCSAMPLEDLG_H__76E480AE_9914_4D00_AEB0_4838EAA5F53A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg dialog

class CVaxVoIP;

class CVCSampleDlg : public CDialog
{
// Construction
public:
	CVCSampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CVCSampleDlg)
	enum { IDD = IDD_VCSAMPLE_DIALOG };
	CListBox	m_ctrlStatusAudioInListBox;
	CListBox	m_ctrlStatusAudioOutListBox;
	CProgressCtrl	m_ctrlMicProg;
	CProgressCtrl	m_ctrlSpkProg;
	CListCtrl	m_ctrlLineStatusList;
	CListBox	m_ctrlStatusLogListBox;
	CListBox	m_ctrlIncomingCallListBox;
	CListBox	m_ctrlIncomingCalIIdListBox;
	CButton	m_ctrlInitButton;
	CComboBox	m_ctrlTransferSelectLine;
	CComboBox	m_ctrlIncomingCallSelectLine;
	CComboBox	m_ctrlPlayWaveSelectLine;
	CComboBox	m_ctrlRecordSelectLine;
	CComboBox	m_ctrlDialSelectLine;
	CSliderCtrl	m_MicSlider;
	CSliderCtrl	m_SpkSlider;
	CString	m_sProxyLoginId;
	CString	m_sProxyLoginPwd;
	CString	m_sProxyURI;
	CString	m_sOutboundProxy;
	CString	m_sPhoneNumber;
	BOOL	m_bMicMute;
	BOOL	m_bSpkMute;
	CString	m_sWavFile;
	BOOL	m_bStartRecording;
	BOOL	m_bEnableEchoNoiseCancel;
	BOOL	m_bEnableMicBoost;
	BOOL	m_bDonotDisturb;
	BOOL	m_bGSM610;
	BOOL	m_biLBC;
	BOOL	m_bG711ALaw;
	BOOL	m_bG711ULaw;
	BOOL	m_bEnableAGC;
	BOOL	m_bEnableSoundDevices;
	int		m_nTotalLines;
	CString	m_sPlayWaveFileName;
	BOOL	m_bPlayListen;
	CString	m_sTransferPhoneNo;
	BOOL	m_bPlayRingTone;
	CString	m_sProxyDisplayName;
	BOOL	m_bCheckRegisterToProxy;
	//}}AFX_DATA

	CVaxVoIP* m_pVaxVoIP;
	
	void OnSuccessToConnect();
	void OnIncomingCallRingingStop(LPCTSTR sCallId);
	void OnIncomingCallRingingStart(LPCTSTR sCallId);
	void OnIncomingCall(LPCTSTR sCallId, LPCTSTR sCLI);
	
	CString GetSelectedItemCallId();
	
	void FillComboBoxes();

	void UpdateLineStatusList();
	void AddToStatusList(LPCTSTR sText);

	CString GetCodecName(int nCodecNo);

	void UpdateAudioInListBox();
	void UpdateAudioOutListBox();

	int GetSelectedAudioOutDeviceId();
	int GetSelectedAudioInDeviceId();

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVCSampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CVCSampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonInit();
	afx_msg void OnDestroy();
	afx_msg void OnButtonClear();
	afx_msg void OnButtonDial();
	afx_msg void OnButtonAccept();
	afx_msg void OnButtonReject();
	afx_msg void OnButtonHangup();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnButton5();
	afx_msg void OnButton6();
	afx_msg void OnButton7();
	afx_msg void OnButton8();
	afx_msg void OnButton9();
	afx_msg void OnButton10();
	afx_msg void OnButton11();
	afx_msg void OnButton12();
	virtual void OnOK();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCheckSpkMute();
	afx_msg void OnCheckMicMute();
	afx_msg void OnButtonResetRecording();
	afx_msg void OnButtonSaveToWaveFile();
	afx_msg void OnCheckStartRecording();
	afx_msg void OnCheckEcho();
	afx_msg void OnCheckMicBoost();
	afx_msg void OnCheckDonotDisturb();
	afx_msg void OnCheckGsm610();
	afx_msg void OnCheckiLBC();
	afx_msg void OnCheckG711ALaw();
	afx_msg void OnCheckG711ULaw();
	afx_msg void OnButtonHelp();
	afx_msg void OnButtonTransferCall();
	afx_msg void OnCheckAgc();
	afx_msg void OnButtonHold();
	afx_msg void OnButtonUnhold();
	afx_msg void OnButtonOpenWave();
	afx_msg void OnButtonWavePlay();
	afx_msg void OnButtonWaveRewind();
	afx_msg void OnButtonWaveForward();
	afx_msg void OnButtonWavePause();
	afx_msg void OnButtonWaveStop();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSelchangeComboRecordSelectLine();
	afx_msg void OnCheckPlayRingTone();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VCSAMPLEDLG_H__76E480AE_9914_4D00_AEB0_4838EAA5F53A__INCLUDED_)
